Index: /branches/2017/dev_r8600_xios_read_write_v2/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90
===================================================================
--- /branches/2017/dev_r8600_xios_read_write_v2/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 8800)
+++ /branches/2017/dev_r8600_xios_read_write_v2/NEMOGCM/NEMO/OPA_SRC/IOM/iom.F90	(revision 8801)
@@ -41,9 +41,10 @@
    USE dianam          ! build name of file
    USE xios
-   USE iom_def, ONLY : max_rst_fields, rst_fields
+   USE iom_def, ONLY : max_rst_fields, rst_rfields, rst_wfields, RST_FIELD
 # endif
    USE ioipsl, ONLY :  ju2ymds    ! for calendar
    USE crs             ! Grid coarsening
    USE lib_fortran 
+   USE diurnal_bulk, ONLY : ln_diurnal_only, ln_diurnal
 
    IMPLICIT NONE
@@ -65,5 +66,6 @@
    PRIVATE iom_set_domain_attr, iom_set_axis_attr, iom_set_field_attr, iom_set_file_attr, iom_get_file_attr, iom_set_grid_attr
    PRIVATE set_grid, set_grid_bounds, set_scalar, set_xmlatt, set_mooring, iom_update_file_name, iom_sdate
-   PRIVATE set_rst_vars, set_rstr_active, set_rst_context
+   PRIVATE iom_set_rst_context, iom_set_rstw_active, iom_set_rstr_active
+   PUBLIC iom_set_rstw_var_active, iom_set_rst_vars
 # endif
 
@@ -92,5 +94,5 @@
 CONTAINS
 
-   SUBROUTINE iom_init( cdname ) 
+   SUBROUTINE iom_init( cdname, fname ) 
       !!----------------------------------------------------------------------
       !!                     ***  ROUTINE   ***
@@ -100,9 +102,10 @@
       !!----------------------------------------------------------------------
       CHARACTER(len=*), INTENT(in)  :: cdname
+      CHARACTER(len=*), OPTIONAL, INTENT(in)  :: fname
 #if defined key_iomput
 
       TYPE(xios_duration) :: dtime    = xios_duration(0, 0, 0, 0, 0, 0)
       TYPE(xios_date)     :: start_date
-      CHARACTER(len=10) :: clname
+      CHARACTER(len=lc) :: clname
       INTEGER           :: ji, jkmin
       LOGICAL :: llrst_context              ! is context related to restart
@@ -117,5 +120,5 @@
       CALL xios_context_initialize(TRIM(clname), mpi_comm_opa)
       CALL iom_swap( cdname )
-      llrst_context =  (TRIM(cdname) == TRIM(crxios_context))
+      llrst_context =  (TRIM(cdname) == TRIM(crxios_context) .OR. TRIM(cdname) == TRIM(cwxios_context))
 
       ! Calendar type is now defined in xml file 
@@ -162,5 +165,5 @@
          CALL dom_grid_glo   ! Return to parent grid domain
          !
-         IF( ln_cfmeta .AND. TRIM(cdname) .NE. TRIM(crxios_context)) THEN   ! Add additional grid metadata
+         IF( ln_cfmeta .AND. .NOT. llrst_context) THEN   ! Add additional grid metadata
             CALL iom_set_domain_attr("grid_T", area = e1e2t_crs(nldi:nlei, nldj:nlej))
             CALL iom_set_domain_attr("grid_U", area = e1u_crs(nldi:nlei, nldj:nlej) * e2u_crs(nldi:nlei, nldj:nlej))
@@ -206,10 +209,16 @@
       ENDIF   
       ! automatic definitions of some of the xml attributs
-      IF( llrst_context ) THEN
-!set names of the fields in restart file IF using XIOS to read/write data
-       CALL set_rst_context()
-       CALL set_rst_vars()
+      IF( TRIM(cdname) == TRIM(crxios_context) ) THEN
+!set names of the fields in restart file IF using XIOS to read data
+       CALL iom_set_rst_context()
+       CALL iom_set_rst_vars(rst_rfields)
 !set which fields are to be read from restart file
-       CALL set_rstr_active()
+       CALL iom_set_rstr_active()
+      ELSE IF( TRIM(cdname) == TRIM(cwxios_context) ) THEN
+!set names of the fields in restart file IF using XIOS to write data
+       CALL iom_set_rst_context()
+       CALL iom_set_rst_vars(rst_wfields)
+!set which fields are to be read from restart file
+       CALL iom_set_rstw_active(fname)
       ELSE
        CALL set_xmlatt
@@ -229,112 +238,30 @@
    END SUBROUTINE iom_init
 
-   
-   SUBROUTINE set_rst_vars()
-!set names for variables in restart file
+   SUBROUTINE iom_set_rstw_var_active(field)
+   CHARACTER(len = *), INTENT(IN) :: field
    INTEGER :: i
-        rst_fields(:)%vname="NO_NAME";         rst_fields(:)%grid="NO_GRID"
-        i = 0
-        i = i + 1; rst_fields(i)%vname="rdt";            rst_fields(i)% grid="grid_scalar"
-        i = i + 1; rst_fields(i)%vname="un";             rst_fields(i)% grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="ub";             rst_fields(i)% grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="vn";             rst_fields(i)% grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="vb";             rst_fields(i)% grid="grid_N_3D"  
-        i = i + 1; rst_fields(i)%vname="tn";             rst_fields(i)% grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="tb";             rst_fields(i)% grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="sn";             rst_fields(i)% grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="sb";             rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="sshn";           rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="sshb";           rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="rhop";           rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="kt";             rst_fields(i)%grid="grid_scalar"
-        i = i + 1; rst_fields(i)%vname="ndastp";         rst_fields(i)%grid="grid_scalar"
-        i = i + 1; rst_fields(i)%vname="adatrj";         rst_fields(i)%grid="grid_scalar"
-        i = i + 1; rst_fields(i)%vname="utau_b";         rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="vtau_b";         rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="qns_b";          rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="emp_b";          rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="sfx_b";          rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="en" ;            rst_fields(i)%grid="grid_N_3D" 
-        i = i + 1; rst_fields(i)%vname="avt";            rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="avm";            rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="avmu";           rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="avmv";           rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="dissl";          rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="sbc_hc_b";       rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="sbc_sc_b";       rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="qsr_hc_b";       rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="fraqsr_1lev";    rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="greenland_icesheet_mass"
-                                               rst_fields(i)%grid="grid_scalar"
-        i = i + 1; rst_fields(i)%vname="greenland_icesheet_timelapsed"
-                                               rst_fields(i)%grid="grid_scalar"
-        i = i + 1; rst_fields(i)%vname="greenland_icesheet_mass_roc"
-                                               rst_fields(i)%grid="grid_scalar"
-        i = i + 1; rst_fields(i)%vname="antarctica_icesheet_mass"
-                                               rst_fields(i)%grid="grid_scalar"
-        i = i + 1; rst_fields(i)%vname="antarctica_icesheet_timelapsed"
-                                               rst_fields(i)%grid="grid_scalar"
-        i = i + 1; rst_fields(i)%vname="antarctica_icesheet_mass_roc"
-                                               rst_fields(i)%grid="grid_scalar"
-        i = i + 1; rst_fields(i)%vname="frc_v";          rst_fields(i)%grid="grid_scalar"
-        i = i + 1; rst_fields(i)%vname="frc_t";          rst_fields(i)%grid="grid_scalar"
-        i = i + 1; rst_fields(i)%vname="frc_s";          rst_fields(i)%grid="grid_scalar"
-        i = i + 1; rst_fields(i)%vname="frc_wn_t";       rst_fields(i)%grid="grid_scalar"
-        i = i + 1; rst_fields(i)%vname="frc_wn_s";       rst_fields(i)%grid="grid_scalar"
-        i = i + 1; rst_fields(i)%vname="ssh_ini";        rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="e3t_ini";        rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="hc_loc_ini";     rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="sc_loc_ini";     rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="ssh_hc_loc_ini"; rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="ssh_sc_loc_ini"; rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="tilde_e3t_b";    rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="tilde_e3t_n";    rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="hdiv_lf";        rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="ub2_b";          rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="vb2_b";          rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="sshbb_e";        rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="ubb_e";          rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="vbb_e";          rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="sshb_e";         rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="ub_e";           rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="vb_e";           rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="fwf_isf_b";      rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="isf_sc_b";       rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="isf_hc_b";       rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="ssh_ibb";        rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="rnf_b";          rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="rnf_hc_b";       rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="rnf_sc_b";       rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="nn_fsbc";        rst_fields(i)%grid="grid_scalar"
-        i = i + 1; rst_fields(i)%vname="ssu_m";          rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="ssv_m";          rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="sst_m";          rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="sss_m";          rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="ssh_m";          rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="e3t_m";          rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="frq_m";          rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="avmb";           rst_fields(i)%grid="grid_vector"
-        i = i + 1; rst_fields(i)%vname="avtb";           rst_fields(i)%grid="grid_vector"
-        i = i + 1; rst_fields(i)%vname="ub2_i_b";        rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="vb2_i_b";        rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="ntime";          rst_fields(i)%grid="grid_scalar"
-        i = i + 1; rst_fields(i)%vname="Dsst";           rst_fields(i)%grid="grid_scalar"
-        i = i + 1; rst_fields(i)%vname="tmask";          rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="umask";          rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="vmask";          rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="smask";          rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="gdepw_n";        rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="e3t_n";          rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="e3u_n";          rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="e3v_n";          rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="surf_ini";       rst_fields(i)%grid="grid_N"
-        i = i + 1; rst_fields(i)%vname="e3t_b";          rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="e3t_n";          rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="mxln";           rst_fields(i)%grid="grid_N_3D"
-        i = i + 1; rst_fields(i)%vname="e3t_m";          rst_fields(i)%grid="grid_N_3D"
-   END SUBROUTINE set_rst_vars
-
-
-   SUBROUTINE set_rstr_active()
+   LOGICAL :: llis_set
+
+   llis_set = .FALSE.
+
+   DO i = 1, max_rst_fields
+       IF(TRIM(rst_wfields(i)%vname) == field) THEN 
+          rst_wfields(i)%active = .TRUE.
+          llis_set = .TRUE.
+          EXIT
+       ENDIF
+   ENDDO
+!Warn if variable is not in defined in rst_wfields
+   IF(.NOT.llis_set) THEN
+      IF(lwp) THEN
+         write(numout,cform_err)
+         write(numout,*) 'iom_set_rstw_var_active: variable ', field ,' is available for writing but not defined' 
+      ENDIF
+        nstop = nstop + 1
+   ENDIF
+
+   END SUBROUTINE iom_set_rstw_var_active
+
+   SUBROUTINE iom_set_rstr_active()
 !sets enabled = .TRUE. for each field in restart file
    CHARACTER(len=256) :: rst_file
@@ -361,28 +288,219 @@
 !defin files for restart context
         DO i = 1, max_rst_fields
-         IF( TRIM(rst_fields(i)%vname) /= "NO_NAME") THEN
-           IF( iom_varid( numror, TRIM(rst_fields(i)%vname), ldstop = .FALSE. ) > 0 ) THEN
-                CALL xios_add_child(file_hdl, field_hdl, TRIM(rst_fields(i)%vname))
-                SELECT CASE (TRIM(rst_fields(i)%grid))
+         IF( TRIM(rst_rfields(i)%vname) /= "NO_NAME") THEN
+           IF( iom_varid( numror, TRIM(rst_rfields(i)%vname), ldstop = .FALSE. ) > 0 ) THEN
+                CALL xios_add_child(file_hdl, field_hdl, TRIM(rst_rfields(i)%vname))
+                SELECT CASE (TRIM(rst_rfields(i)%grid))
                  CASE ("grid_N_3D")
-                    CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(rst_fields(i)%vname), &
+                    CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(rst_rfields(i)%vname), &
                         domain_ref="grid_N", axis_ref="deptht", operation = "instant")
                  CASE ("grid_N")
-                    CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(rst_fields(i)%vname), &
+                    CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(rst_rfields(i)%vname), &
                         domain_ref="grid_N", operation = "instant") 
                 CASE ("grid_vector")
-                    CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(rst_fields(i)%vname), &
+                    CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(rst_rfields(i)%vname), &
                          axis_ref="deptht", operation = "instant")
                  CASE ("grid_scalar")
-                    CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(rst_fields(i)%vname), &
+                    CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(rst_rfields(i)%vname), &
                         scalar_ref = "grid_scalar", operation = "instant")
                 END SELECT
-                IF(lwp) WRITE(numout,*) 'XIOS read: ', TRIM(rst_fields(i)%vname), ' enabled in ', TRIM(rst_file)
+                IF(lwp) WRITE(numout,*) 'XIOS read: ', TRIM(rst_rfields(i)%vname), ' enabled in ', TRIM(rst_file)
            ENDIF
          ENDIF
         END DO
-   END SUBROUTINE set_rstr_active
-
-   SUBROUTINE set_rst_context( ) 
+   END SUBROUTINE iom_set_rstr_active
+
+   SUBROUTINE iom_set_rstw_core()
+!from restart.F90
+   CALL iom_set_rstw_var_active("rdt")
+   IF ( .NOT. ln_diurnal_only ) THEN
+        CALL iom_set_rstw_var_active('ub'  )
+        CALL iom_set_rstw_var_active('vb'  )
+        CALL iom_set_rstw_var_active('tb'  )
+        CALL iom_set_rstw_var_active('sb'  )
+        CALL iom_set_rstw_var_active('sshb')
+        !
+        CALL iom_set_rstw_var_active('un'  )
+        CALL iom_set_rstw_var_active('vn'  )
+        CALL iom_set_rstw_var_active('tn'  )
+        CALL iom_set_rstw_var_active('sn'  )
+        CALL iom_set_rstw_var_active('sshn')
+        CALL iom_set_rstw_var_active('rhop')
+     ! extra variable needed for the ice sheet coupling
+        IF ( ln_iscpl ) THEN
+             CALL iom_set_rstw_var_active('tmask')
+             CALL iom_set_rstw_var_active('umask')
+             CALL iom_set_rstw_var_active('vmask')
+             CALL iom_set_rstw_var_active('smask')
+             CALL iom_set_rstw_var_active('e3t_n')
+             CALL iom_set_rstw_var_active('e3u_n')
+             CALL iom_set_rstw_var_active('e3v_n')
+             CALL iom_set_rstw_var_active('gdepw_n')
+        END IF
+      ENDIF
+      IF(ln_diurnal) CALL iom_set_rstw_var_active('Dsst')
+!from trasbc.F90
+         CALL iom_set_rstw_var_active('sbc_hc_b')
+         CALL iom_set_rstw_var_active('sbc_sc_b')
+   END SUBROUTINE iom_set_rstw_core
+
+   SUBROUTINE iom_set_rst_vars(fields)
+!set names for variables in restart file
+   TYPE(RST_FIELD), INTENT(INOUT) :: fields(max_rst_fields)
+   INTEGER :: i
+        i = 0
+        i = i + 1; fields(i)%vname="rdt";            fields(i)%grid="grid_scalar"
+        i = i + 1; fields(i)%vname="un";             fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="ub";             fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="vn";             fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="vb";             fields(i)%grid="grid_N_3D"  
+        i = i + 1; fields(i)%vname="tn";             fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="tb";             fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="sn";             fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="sb";             fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="sshn";           fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="sshb";           fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="rhop";           fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="kt";             fields(i)%grid="grid_scalar"
+        i = i + 1; fields(i)%vname="ndastp";         fields(i)%grid="grid_scalar"
+        i = i + 1; fields(i)%vname="adatrj";         fields(i)%grid="grid_scalar"
+        i = i + 1; fields(i)%vname="utau_b";         fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="vtau_b";         fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="qns_b";          fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="emp_b";          fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="sfx_b";          fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="en" ;            fields(i)%grid="grid_N_3D" 
+        i = i + 1; fields(i)%vname="avt";            fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="avm";            fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="avmu";           fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="avmv";           fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="dissl";          fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="sbc_hc_b";       fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="sbc_sc_b";       fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="qsr_hc_b";       fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="fraqsr_1lev";    fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="greenland_icesheet_mass"
+                                               fields(i)%grid="grid_scalar"
+        i = i + 1; fields(i)%vname="greenland_icesheet_timelapsed"
+                                               fields(i)%grid="grid_scalar"
+        i = i + 1; fields(i)%vname="greenland_icesheet_mass_roc"
+                                               fields(i)%grid="grid_scalar"
+        i = i + 1; fields(i)%vname="antarctica_icesheet_mass"
+                                               fields(i)%grid="grid_scalar"
+        i = i + 1; fields(i)%vname="antarctica_icesheet_timelapsed"
+                                               fields(i)%grid="grid_scalar"
+        i = i + 1; fields(i)%vname="antarctica_icesheet_mass_roc"
+                                               fields(i)%grid="grid_scalar"
+        i = i + 1; fields(i)%vname="frc_v";          fields(i)%grid="grid_scalar"
+        i = i + 1; fields(i)%vname="frc_t";          fields(i)%grid="grid_scalar"
+        i = i + 1; fields(i)%vname="frc_s";          fields(i)%grid="grid_scalar"
+        i = i + 1; fields(i)%vname="frc_wn_t";       fields(i)%grid="grid_scalar"
+        i = i + 1; fields(i)%vname="frc_wn_s";       fields(i)%grid="grid_scalar"
+        i = i + 1; fields(i)%vname="ssh_ini";        fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="e3t_ini";        fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="hc_loc_ini";     fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="sc_loc_ini";     fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="ssh_hc_loc_ini"; fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="ssh_sc_loc_ini"; fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="tilde_e3t_b";    fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="tilde_e3t_n";    fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="hdiv_lf";        fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="ub2_b";          fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="vb2_b";          fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="sshbb_e";        fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="ubb_e";          fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="vbb_e";          fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="sshb_e";         fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="ub_e";           fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="vb_e";           fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="fwf_isf_b";      fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="isf_sc_b";       fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="isf_hc_b";       fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="ssh_ibb";        fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="rnf_b";          fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="rnf_hc_b";       fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="rnf_sc_b";       fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="nn_fsbc";        fields(i)%grid="grid_scalar"
+        i = i + 1; fields(i)%vname="ssu_m";          fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="ssv_m";          fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="sst_m";          fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="sss_m";          fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="ssh_m";          fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="e3t_m";          fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="frq_m";          fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="avmb";           fields(i)%grid="grid_vector"
+        i = i + 1; fields(i)%vname="avtb";           fields(i)%grid="grid_vector"
+        i = i + 1; fields(i)%vname="ub2_i_b";        fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="vb2_i_b";        fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="ntime";          fields(i)%grid="grid_scalar"
+        i = i + 1; fields(i)%vname="Dsst";           fields(i)%grid="grid_scalar"
+        i = i + 1; fields(i)%vname="tmask";          fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="umask";          fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="vmask";          fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="smask";          fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="gdepw_n";        fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="e3t_n";          fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="e3u_n";          fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="e3v_n";          fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="surf_ini";       fields(i)%grid="grid_N"
+        i = i + 1; fields(i)%vname="e3t_b";          fields(i)%grid="grid_N_3D"
+        i = i + 1; fields(i)%vname="mxln";           fields(i)%grid="grid_N_3D"
+
+        IF( i-1 > max_rst_fields) THEN
+        IF(lwp) write(numout,*) 'E R R O R : iom_set_rst_vars SIZE of RST_FIELD array is too small'
+        nstop = nstop + 1
+        ENDIF
+
+   END SUBROUTINE iom_set_rst_vars
+
+
+   SUBROUTINE iom_set_rstw_active(cdrst_file)
+!sets enabled = .TRUE. for each field in restart file
+   CHARACTER(len=*) :: cdrst_file
+#if defined key_iomput
+   TYPE(xios_field) :: field_hdl
+   TYPE(xios_file) :: file_hdl
+   TYPE(xios_filegroup) :: filegroup_hdl
+   INTEGER :: i
+   CHARACTER(lc)  ::   clpath
+
+!set name of the restart file and enable available fields
+        IF(lwp) WRITE(numout,*) 'Setting restart filename (for XIOS write) to: ',cdrst_file
+        CALL xios_get_handle("file_definition", filegroup_hdl )
+        CALL xios_add_child(filegroup_hdl, file_hdl, 'wrestart')
+        IF(nxioso.eq.1) THEN 
+           CALL xios_set_file_attr( "wrestart", type="one_file", enabled=.TRUE.,& 
+                                    mode="write", output_freq=xios_timestep) 
+           if(lwp) write(numout,*) 'OPEN ', trim(cdrst_file), ' in one_file mode' 
+        ELSE  
+           CALL xios_set_file_attr( "wrestart", type="multiple_file", enabled=.TRUE.,& 
+                                    mode="write", output_freq=xios_timestep) 
+           if(lwp) write(numout,*) 'OPEN ', trim(cdrst_file), ' in multiple_file mode' 
+        ENDIF 
+        CALL xios_set_file_attr( "wrestart", name=trim(cdrst_file))
+!defin files for restart context
+        DO i = 1, max_rst_fields
+         IF( rst_wfields(i)%active ) THEN
+                CALL xios_add_child(file_hdl, field_hdl, TRIM(rst_wfields(i)%vname))
+                SELECT CASE (TRIM(rst_wfields(i)%grid))
+                 CASE ("grid_N_3D")
+                    CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(rst_wfields(i)%vname), &
+                        domain_ref="grid_N", axis_ref="deptht", prec = 8, operation = "instant")
+                 CASE ("grid_N")
+                    CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(rst_wfields(i)%vname), &
+                        domain_ref="grid_N", prec = 8, operation = "instant") 
+                 CASE ("grid_vector")
+                    CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(rst_wfields(i)%vname), &
+                         axis_ref="deptht", prec = 8, operation = "instant")
+                 CASE ("grid_scalar")
+                    CALL xios_set_attr (field_hdl, enabled = .TRUE., name = TRIM(rst_wfields(i)%vname), &
+                        scalar_ref = "grid_scalar", prec = 8, operation = "instant")
+                END SELECT
+         ENDIF
+        END DO
+#endif
+   END SUBROUTINE iom_set_rstw_active
+
+   SUBROUTINE iom_set_rst_context( ) 
 #if defined key_iomput
    TYPE(xios_domaingroup)            :: domaingroup_hdl 
@@ -407,5 +525,5 @@
      CALL xios_add_child(scalargroup_hdl, scalar_hdl, "grid_scalar") 
 #endif
-   END SUBROUTINE set_rst_context
+   END SUBROUTINE iom_set_rst_context
 
    SUBROUTINE iom_swap( cdname )
@@ -418,5 +536,4 @@
 #if defined key_iomput
       TYPE(xios_context) :: nemo_hdl
-
       IF( TRIM(Agrif_CFixed()) == '0' ) THEN
         CALL xios_get_handle(TRIM(cdname),nemo_hdl)
@@ -1363,5 +1480,5 @@
    !!                   INTERFACE iom_rstput
    !!----------------------------------------------------------------------
-   SUBROUTINE iom_rp0d( kt, kwrite, kiomid, cdvar, pvar, ktype )
+   SUBROUTINE iom_rp0d( kt, kwrite, kiomid, cdvar, pvar, ktype, ldxios )
       INTEGER         , INTENT(in)                         ::   kt       ! ocean time-step
       INTEGER         , INTENT(in)                         ::   kwrite   ! writing time-step
@@ -1370,18 +1487,32 @@
       REAL(wp)        , INTENT(in)                         ::   pvar     ! written field
       INTEGER         , INTENT(in), OPTIONAL               ::   ktype    ! variable external type
+      LOGICAL, OPTIONAL :: ldxios   ! xios write flag
+      LOGICAL :: llx                ! local xios write flag
       INTEGER :: ivid   ! variable id
-      IF( kiomid > 0 ) THEN
-         IF( iom_file(kiomid)%nfid > 0 ) THEN
-            ivid = iom_varid( kiomid, cdvar, ldstop = .FALSE. )
-            SELECT CASE (iom_file(kiomid)%iolib)
-            CASE (jpnf90   )   ;   CALL iom_nf90_rstput(   kt, kwrite, kiomid, cdvar, ivid, ktype, pv_r0d = pvar )
-            CASE DEFAULT
-               CALL ctl_stop( 'iom_rp0d: accepted IO library is only jpnf90 (jpioipsl option has been removed)' )
-            END SELECT
+
+      llx = .FALSE.
+      IF(PRESENT(ldxios)) llx = ldxios
+      IF( llx ) THEN
+#ifdef key_iomput
+      IF( kt == kwrite ) THEN
+          IF(lwp) write(numout,*) 'RESTART: write (XIOS 0D) ',trim(cdvar)
+          CALL xios_send_field(trim(cdvar), pvar)
+      ENDIF
+#endif
+      ELSE
+         IF( kiomid > 0 ) THEN
+            IF( iom_file(kiomid)%nfid > 0 ) THEN
+               ivid = iom_varid( kiomid, cdvar, ldstop = .FALSE. )
+               SELECT CASE (iom_file(kiomid)%iolib)
+               CASE (jpnf90   )   ;   CALL iom_nf90_rstput(   kt, kwrite, kiomid, cdvar, ivid, ktype, pv_r0d = pvar )
+               CASE DEFAULT     
+                  CALL ctl_stop( 'iom_rp0d: accepted IO library is only jpnf90 (jpioipsl option has been removed)' )
+               END SELECT
+            ENDIF
          ENDIF
       ENDIF
    END SUBROUTINE iom_rp0d
 
-   SUBROUTINE iom_rp1d( kt, kwrite, kiomid, cdvar, pvar, ktype )
+   SUBROUTINE iom_rp1d( kt, kwrite, kiomid, cdvar, pvar, ktype, ldxios )
       INTEGER         , INTENT(in)                         ::   kt       ! ocean time-step
       INTEGER         , INTENT(in)                         ::   kwrite   ! writing time-step
